/*-----------------------------------------------*/
//Project: Robot piano player. //
// //
// //
//Programmer: Klyushkin Sergey //
// //
/*-----------------------------------------------*/
int key_piano[1000];
int hold[1000];
int ping[1000];
/**/int update_switch;
/**/int main_finger;
int current_position1=1;
int current_position2=5;
int i=0;//number of keys
int imax=0;//used when reading ended, to get amount of keys (final)
int speed;//defines speed of robot. speed 100 = max speed to right, -100 max speed to left, 0 = stop
void file_read()
/*data store like key(1)_ping(1)_hold(1) key(2)_ping(2)_hold(2) etc.
WARNING!!! FOR LAST HOLD TO WORK YOU NEED TO PLACE _ at the end!!!
note example: C3_5000_1999
///////////// ^ ^ ^
///////////// | | |
/////////////note code ping hold
note code = (letter number)*1(number for key) + number*7 (oktava)
(space) means it is next key*/
{
long h;//file desriptor
short k;//reading byte
int timed[4];//massive for timed values (for storing hold and ping into 1 value)
int t=0;//for timed massive
int switcher=0;//to swtich from key_piano (0%3) to ping (1%3) to hold (2%3) etc.
h=fileOpenRead("reading_file_test.");
//k = 32 means it is space, k = 95 means it is _. 48<=k<=64 means it is 0-9. 64<=k<=92 means it is A-Z
while(fileReadShort(h, &k))
{
if (k==95 | k==32)//switches to another data folder when _ found
{
if (switcher%3==0)
{
key_piano[i]=(timed[0]-16) + timed[1]*7;
timed[0]=0;
timed[1]=0;
t=0;
}
if (switcher%3==1)
{
ping[i]=timed[0]*1000 + timed[1]*100 + timed[2]*10 + timed[3];
timed[0]=0;
timed[1]=0;
timed[2]=0;
timed[3]=0;
t=0;
}
if (switcher%3==2)
{
hold[i]=timed[0]*1000 + timed[1]*100 + timed[2]*10 + timed[3];
timed[0]=0;
timed[1]=0;
timed[2]=0;
timed[3]=0;
t=0;
}
switcher = switcher + 1;
if (k==32)//writes next note
i=i+1;
}
if (k!=32 & k<91)//container for timed values (ex. => converting 1234 into 1 value)
{
timed[t]=k-48;
t=t+1;
}
}
imax = i+1;
fileClose(h);
i=0;
}

task debug_show
{
while (true) //debug show, turn off comments to enable debug
{
if (getButtonPress(buttonRight)==1 & i<imax)
{
i=i+1;
wait1Msec(200);
}
if (getButtonPress(buttonLeft)==1 & i>0)
{
i=i-1;
wait1Msec(200);
}
displayTextLine(1,"key info for %d",i+1);
displayTextLine(2,"key number - %d",key_piano[i]);
displayTextLine(3,"key ping - %d",ping[i]);
displayTextLine(4,"key hold - %d",hold[i]);
displayTextLine(5,"main_finger - %d",main_finger);
displayTextLine(6,"current_position2 - %d",current_position2);
displayTextLine(7,"current_position1 - %d",current_position1);
displayTextLine(8,"speed - %d",speed);
displayTextLine(9,"update_switch - %d",update_switch);
displayTextLine(10,"timer current - %d",time1[timer1]);
displayTextLine(11,"sensor color 1 - %d",SensorValue[S2]);
displayTextLine(12,"sensor color 2 - %d",SensorValue[S3]);
displayTextLine(13,"i - %d",i);
displayTextLine(14,"imax - %d",imax);
wait1Msec(1);
}
}

void press_key()
{
speed=0;
while (time1[timer1]<ping[i])
wait1Msec(1);
if (main_finger==1)
{
setMotorSpeed(motorA,15);
wait1Msec(300);
setMotorSpeed(motorA,0);
wait1Msec(hold[i]-300);
update_switch=1;
setMotorSpeed(motorA,-15);
wait1Msec(300);
setMotorSpeed(motorA,0);
}
if (main_finger==2)
{
setMotorSpeed(motorD,15);
wait1Msec(300);
setMotorSpeed(motorD,0);
wait1Msec(hold[i]-300);
update_switch=1;
setMotorSpeed(motorD,-15);
wait1Msec(300);
setMotorSpeed(motorD,0);
}
i=i+1;
}


task speed_control() //for speed
{
while (true)
{
motor[motorC]= speed;
motor[motorB]= speed*-1;
wait1Msec(1);
}
}

//var's: current_position1,current_position2 stand for places for motors
//speed stands for speed of robot
//i - current key (place from 1-i) imax - number of all keys (max i)
//update switch - becomes 1 when i updated, otherwise turns off use for this-|
//main_finger - says which finger targets the key<---------------------------/
//key_real_max - ammount of keys on piano
//
task main()
{
startTask (speed_control);
startTask(debug_show);
file_read();
update_switch=1;
while (SensorValue[S1]==0)
{
speed=-20
;
}
////////////////////////////////
while (i<imax)
{
/**/if(update_switch==1)
{
if (abs(key_piano[i]-current_position1)<abs(key_piano[i]-current_position2))
{
main_finger=1;
update_switch=0;
time1[timer1]=0;
}
else
{
main_finger=2;
wait1Msec(1000);
update_switch=0;
time1[timer1]=0;
}
/**/}

if (main_finger==1)
{
speed=(key_piano[i]-current_position1)*15;
}
//////
if (main_finger==2)
{
speed=(key_piano[i]-current_position2)*15;
}
//////
if (SensorValue[S2]<40 | SensorValue[S3]<40 & speed>0)
{
current_position1=current_position1+1;
current_position2=current_position2+1;
wait1Msec(700);
}
//////
else
{
if (SensorValue[S2]<40 | SensorValue[S3]<40 & speed<0)
{
current_position1=current_position1-1;
current_position2=current_position2-1;
wait1Msec(700);
}
}
//////
if (speed==0)
press_key();
}
////////////////////////////////
}
